import { CodeMaker } from 'codemaker';
export declare enum Language {
    TYPESCRIPT = "typescript",
    PYTHON = "python",
    DOTNET = "dotnet",
    JAVA = "java"
}
export declare const LANGUAGES: Language[];
export interface GetOptions {
    readonly targetLanguage: Language;
    readonly outdir: string;
    readonly targetNames: string[];
}
export declare abstract class GetBase {
    protected abstract generateTypeScript(code: CodeMaker, targetNames: string[]): Promise<void>;
    get(options: GetOptions): Promise<void>;
    private harvestCode;
    private harvestPython;
}
